#!/usr/local/bin/perl
# Copyright 2002 Benjamin Trott.
# This code is released under the Artistic License.
use strict;


my $Charset = 'big5';
my $DataDir = "./tbdir";
my $RSSDir = "./rssdir";
my $tbpath = "./tb.cgi";
my $Pkey = "0628";
my $TrackbackUrl = './';
my $vDir = '.';
unshift @INC, './lib';

use vars qw( $VERSION );
$VERSION = '1.02c.20040903';

use CGI qw( :standard );

eval('charset $Charset');

my $pms = param('__mode');
my $oth;
my $mode;
($mode, $oth)=split(/\?/, $pms) if( $pms );

unless ($mode) {
 my $r1 = rindex($ENV{SCRIPT_NAME}, "/");
 unless( substr($ENV{SCRIPT_NAME}, $r1+1) eq "tb.cgi" ){1;}else{
    my $tb_id = munge_tb_id(get_tb_id());
    respond_exit("No TrackBack ID (tb_id)") unless $tb_id;
	my $url=delTag(param('url'));
    respond_exit("No URL (url)") unless $url;

	my $title=delTag(param('title'));
	$title ||=$url;
	my $excerpt=delTag(param('excerpt'));
	my $blog_name=delTag(param('blog_name'));
	my $cset=delTag(param('charset'));
	my ($header, $footer, $custom, $ping_msg, $custom_admin, $lst, $blogname_max, $title_max, $excerpt_max, $mto)=get_custom();
	my ($sendmail_path, $mail_address)=split(/\x02/, $mto);
	require Jcode;
	my $code = {
	'utf-8'=>'utf8','iso-2022-jp'=>'jis','shift_jis'=>'sjis','BIG5'=>'euc'
	}->{lc($cset)} || Jcode::getcode($excerpt . $title . $blog_name);

	my $dummy;
	($title, $dummy)=split(/\n/, Jcode->new($title, $code)->jfold($title_max)->euc());
	($excerpt, $dummy)=split(/\n/, Jcode->new($excerpt, $code)->jfold($excerpt_max)->euc());
	($blog_name, $dummy)=split(/\n/, Jcode->new($blog_name, $code)->jfold($blogname_max)->euc());

	my $rej=is_reject($ENV{'HTTP_HOST'}, $ENV{'HTTP_ADDR'}, $url);
	send_email($tb_id, $sendmail_path, $mail_address, $url, $rej);
	if( $rej )
	{
		add_data($tb_id, $title, $excerpt, $blog_name, $url, time,
				$ENV{'HTTP_HOST'}, $ENV{'HTTP_ADDR'});
		make_nicky_log($tb_id);
		respond_exit();
	}
	respond_exit("Reject");

 }
} elsif( $mode eq 'num' ){
	my $tb_id=param('tb_id');
	my $str=header()."document.write('(";
	if( $tb_id ){
		my @data=get_data($tb_id);
		my $i=0;
		for my $record(@data){
			my($tb_idr, $dummy)=split(/\x01/, $record);
			$i++ if( $tb_id eq $tb_idr );
		}
		$str .= "$i";
	}else{
		$str .= "no tb_id";
	}
	print $str, ")')\n";
} elsif ($mode eq 'red' ){
my $tb_id="20040421A";
open WD, ">./junkfile2";
print WD redirect("./nicky.cgi");
print WD "bac\n";
close WD;
#   print redirect("tb.cgi" . "?__mode=list&tb_id=$tb_id");
    print redirect("./nicky.cgi" . "?__mode=list&tb_id=$tb_id");
} elsif ($mode eq 'list') {
	put_list();
} elsif ($mode eq 'testreject' ){
my $ip=param('ip');
my $hn=param('hn');
my $url=param('url');
print header();
print "<html><body>\n";
if( isTBadmin() ){
 my $ret=is_reject($hn, $ip, $url);
 if( $ret ){
	print "Pass\n";
 }else{
	print "Reject\n";
 }
}
print "</body></html>\n";
} elsif ($mode eq 'delete') {
	die "You are not authorized" unless isTBadmin();
    my $tb_id = munge_tb_id(get_tb_id());
    die("No TrackBack ID (tb_id)") unless $tb_id;
	my $index = param('index') || 0;
	delete_tb($tb_id, $index);
	make_nicky_log($tb_id);
    print redirect(url() . "?__mode=list&tb_id=$tb_id");
} elsif ($mode eq 'rss') {
    my $tb_id = munge_tb_id(get_tb_id());
    respond_exit("No TrackBack ID (tb_id)") unless $tb_id;
	my @data=get_data($tb_id);
	my @rssdat;
	for my $record( @data ){
		my($tb_idr, $title, $excerpt, $blog_name, $url, $time, $host, $addr)=
														split(/\x01/, $record);
		if( $tb_id eq $tb_idr ){
			@rssdat=(@rssdat, $record);
		}elsif( $tb_id =~ /alldata/ ){
			@rssdat=(@rssdat, $record);
		}
	}
	respond_exit(undef, generate_rss($tb_id, @rssdat));
} elsif ($mode eq 'send_ping') {
	require Jcode;
    require LWP::UserAgent;
    my $ua = LWP::UserAgent->new;
    $ua->agent("TrackBack/$VERSION");

	my @qs = map $_ . '=' . encode_url(Jcode->new(param($_) || '', 'euc')->utf8()),qw( title excerpt blog_name );
	push @qs, "url=".encode_url(param('url') || '');
	push @qs, "charset=utf-8";
    my $ping = param('ping_url') or ping_form_exit("No ping URL");
    my $req;

    if ($ping =~ /\?/) {
        $req = HTTP::Request->new(GET => $ping . '&' . join('&', @qs));
    } else {
        $req = HTTP::Request->new(POST => $ping);
        $req->content_type('application/x-www-form-urlencoded');
        $req->content(join('&', @qs));
    }
    my $res = $ua->request($req);
    ping_form_exit("HTTP error: " . $res->status_line) unless $res->is_success;
    my($e, $msg) = $res->content =~ m!<error>(\d+).*<message>(.+?)</message>!s;
    $e ? ping_form_exit("Error: $msg") : ping_form_exit("Ping successfuly sent");
} elsif ($mode eq 'send_form') {
    ping_form_exit($oth);
} elsif ($mode eq 'PassWord' ) {
	&password_form();
} elsif ($mode eq 'setup_password'){
	print password_done();
} elsif ($mode eq 'dummy_password' ){
	print dummy_password();
} elsif ($mode eq 'custom'){
	edit_tb();
} elsif ($mode eq 'write_custom'){
	write_custom();
}

sub get_tb_id {
    my $tb_id = param('tb_id');
    unless ($tb_id) {
        if (my $pi = path_info()) {
            ($tb_id = $pi) =~ s!^/!!;
        }
    }
    $tb_id;
}

sub munge_tb_id {
    my($id) = @_;
    return '' unless $id;
    $id =~ tr/a-zA-Z0-9/_/cs;
    $id;
}

sub delete_tb{
my($tb_id, $index)=@_;
my @data=get_data($tb_id);
my $tb_idr;
my @ary;
my $tb_file = get_file_name($tb_id);

open FH, ">" . $tb_file;
binmode FH;
for my $item(@data){
	($tb_idr, @ary)=split(/\x01/, $item);
	if( $tb_id eq $tb_idr ){
		print FH $item."\x02" unless( $index == $ary[4] );
	}else{
		print FH $item."\x02";
	}
}
close FH;
}

sub is_reject{
my(@listdat)=@_;
my $ret=1;
my $dat=from_file("./reject_list.cgi");
my $line;
my @ysl;
my $ys;

$dat=~s/\r//g;
$dat=~s/\r| //g;
for $line(split(/\n/, $dat)){
	@ysl=split(/\./, $line);
	for $ys(@listdat){
		if( substr($line, length($line)-1) eq '*' ){
			if( $ys =~ /^$line/ ){
				$ret=0;
				last;
			}
		}else{
			if( $ys =~ /^$line$/ ){
				$ret=0;
				last;
			}
		}
	}
	last if( !$ret );
}
$ret;
}

sub get_file_name{
my($tb_id)=@_;
my $y=substr($tb_id, 0, 4);
my $m=substr($tb_id, 4, 2);

"$DataDir/$y$m.cgi";
}

sub del_daytb {
	my($year, $month, $day, $daysub)=@_;
	my $tb_id  = "$year$month$day$daysub";
	my $itemid = "$year$month$day";
	my $tb_file= get_file_name($tb_id);
	my @data   = get_data($tb_id);
	my @ary;
	my $tb_idr;
	my $ds;
	my $dsubord;

	$dsubord=ord($daysub);
	open FH, ">" . $tb_file;
	binmode FH;
	for my $item(@data){
		($tb_idr, @ary)=split(/\x01/, $item);
		if( $tb_idr !~ /$itemid[A-Za-z]/ ){
			print FH $item."\x02";
		}else{
			$ds=ord(substr($tb_idr, 8));
			if( $ds == $dsubord ){
			}elsif( $ds < $dsubord ){
				print FH $item."\x02";
			}else{
				print FH $itemid;
				print FH sprintf("%c\x01", $ds-1);
				print FH "$ds\x01";
				for $ds(@ary){
					print FH "$ds\x01";
				}
				print FH "\x02";
			}
		}
	}
	close FH;
}

sub make_nicky_log {
my($tb_id)=@_;
my $year=substr($tb_id, 0, 4);
my $month=substr($tb_id, 4, 2);
my $day=substr($tb_id, 6, 2);
my $daysub=substr($tb_id, 8, 1);
local *WD;

eval('require("./nicky.cgi")');
 unless( $@ ){
	ReadSetup();
	initial2nd();
	MakeHTMLone($year, $month, $day, $daysub, 0);
	MakeLastHTMLsub();
 }
}

sub get_data {
	my($tb_id)=@_;
	my $tb_file = get_file_name($tb_id);
	my $all_dat;
	if( open FH, $tb_file ){
		binmode FH;
		while (<FH>){
			$all_dat.=$_;
		} close FH;
	}

	split(/\x02/, $all_dat);
}

sub add_data {
	my($tb_idr, $title, $excerpt, $blog_name, $url, $time, $host, $addr)=@_;
	my $tb_id=$_[0];
	my $tb_file = get_file_name($tb_id);

	open FH, ">>$tb_file";
	binmode FH;
	print FH "$tb_idr\x01$title\x01$excerpt\x01$blog_name\x01$url\x01$time\x01$host\x01$addr\x02";
	close FH;
}

sub generate_rss {
    my($tb_id, @data) = @_;
    my $rss = qq(<rss version="0.91"><channel><title>TB: $tb_id</title>\n);
#    my $max = $limit ? $limit - 1 : $#$data;
#    for my $i (@{$data}[0..$max]) {
#        $rss .= sprintf "<item>%s%s%s</item>\n", xml('title', $i->{title}),
#                xml('link', $i->{url}), xml('description', $i->{excerpt}) if $i;
#    }

    my $max = 50;
    for my $record (@data[0..$max]) {
		my($tb_idr, $title, $excerpt, $blog_name, $url, $time, $host, $addr)=
														split(/\x01/, $record);
        $rss .= sprintf "<item>%s%s%s</item>\n", xml('title', $title),
                xml('link', $url), xml('description', $excerpt) if $record;
    }

    $rss . qq(</channel></rss>);
}

sub put_list {
	my $tb_id = munge_tb_id(get_tb_id());
	my ($header, $footer, $custom, $ping_msg, $custom_admin, $lst)=get_custom();
	die("No TrackBack ID (tb_id)") unless $tb_id;
	my $url_me = url();
	my @week_str=('(Sun)','(Mon)','(Tue)','(Wed)','(Thu)','(Fri)','(Sat)');
	my $url_nicky=$url_me;
	$url_nicky=~s/tb.cgi/nicky.cgi/;
	$url_nicky="$url_nicky?DT=$tb_id#$tb_id";

	my($title, $msgall)=get_nicky_file($tb_id);
	my($msg, $dummy)=split(/<br>|<br \/>/, $msgall);
	$msg=delTag($msg);
	$title=delTag($title);
	$dummy=from_file("./tb_admin.cgi");
	my($dummy1, $page_title)=split(/\n/, $dummy);

	$ping_msg=~s/\$url_ping/$url_me\/$tb_id/g;
	$ping_msg=~s/\$tb_id/$tb_id/g;
	$ping_msg=~s/\$url_nicky/$url_nicky/g;
	$ping_msg=~s/\$title/$title/g;
	$ping_msg=~s/\$msg/$msg/g;

	$header=~s/\$url_ping/$url_me\/$tb_id/g;

	print header(-charset => $Charset), $header, $ping_msg;
	my @data = get_data($tb_id);
	my $i = 0;
	my $logged_in = isTBadmin();
	my $cstr;
	my $templ;

	@data=reverse(@data) if( $lst eq "new" );

	for my $record (@data) {
		my($tb_idr, $title, $excerpt, $blog_name, $url, $ltime, $host, $addr)=split(/\x01/, $record);
	  if( $tb_idr eq $tb_id ){
		my($csec,$cmin,$chour,$cday,$cmon,$cyear,$cwday,$cyday,$cisdst)=
			localtime $ltime;
		my $ts=sprintf("%04d/%02d/%02d%s %02d:%02d", $cyear+1900, $cmon+1, $cday, @week_str[($cwday%7)], $chour, $cmin);

		$templ=$custom;
		$templ=~s/\$url/$url/g;
		$templ=~s/\$tb_title/$title/g;
		$blog_name ||= "[No blog name]";
		$templ=~s/\$blog_name/$blog_name/g;
		$excerpt ||= "[No excerpt]";
		$templ=~s/\$excerpt/$excerpt/g;
		$templ=~s/\$time/$ts/g;
		$cstr=$logged_in ? qq(<a class="delete" href="$url_me?__mode=delete&tb_id=$tb_id&index=$ltime">[DELETE]</a>) : '';
		$templ=~s/\$delete/$cstr/g;

		print $templ;
        $i++;
	  }
    }

	if( isTBadmin() ){
		$page_title=~s/\n|\r|\t//g;
		while( $page_title=~s/ $// ){}
		$custom_admin=~s/\$msg/$msg/g;
		$custom_admin=~s/\$title/$title/g;
		$custom_admin=~s/\$page_title/$page_title/g;
		$custom_admin=~s/\$url_nicky/$url_nicky/g;
		print $custom_admin;
	}

	$footer=~s/\$url_ping/$url_me\/$tb_id/g;
	print $footer;
}

sub send_email {
	my($tb_id, $sendmail_path, $mail_address, $url, $rej)=@_;
	my($subject)="=?BIG5?B?GyRCJUglaSVDJS8lUCVDJS9ETENOGyhC?=";
	if( $sendmail_path && $mail_address ){
		open(FH, "|$sendmail_path -t -Fnicky");
		binmode FH;
		print FH "To: $mail_address\n";
		print FH "Subject: $subject\n";
		print FH "Content-Type: text/plain; charset=BIG5\n";
		print FH "Content-Transfer-Encoding: 8bit\n";
		print FH "\n";
		print FH "from  : $ENV{REMOTE_HOST}($ENV{REMOTE_ADDR})\n";
		print FH "        $url\n";
		print FH "agent : $ENV{HTTP_USER_AGENT}\n\n";
		print FH "http://$ENV{HTTP_HOST}$ENV{SCRIPT_NAME}\?tb_id=$tb_id&__mode=list\n\n";
		if( !$rej ){
			print FH "REJECT\n\n";
		}
		close FH;
	}
}

sub respond_exit {
    print "Content-Type: text/xml; charset=BIG5\n\n";
    print qq(<?xml version="1.0" encoding="BIG5"?>\n<response>\n);
    if ($_[0]) {
        printf qq(<error>1</error>\n%s\n), xml('message', $_[0]);
    } else {
        print qq(<error>0</error>\n) . ($_[1] ? $_[1] : '');
    }
    print "</response>\n";
    exit;
}

sub ping_form_exit {
	my($oth) = @_;
	my($subp, $subv)=split(/=/, $oth);
	my $ping_url_str;
	my $ping_url_for_blog;
	my($header,$footer,$custom,$ping_msg,$custom_admin, $lst)=get_custom();

    print header(), $header;

	unless( $oth ){
	    print $footer;
	    exit;
	}elsif( $subp eq "ping_url" ){
		$ping_url_str="</td><td><input type=\"hidden\" name=\"ping_url\" size=\"60\" value=\"$subv\" />";
		$ping_url_for_blog="gOTrackBack<a href=\"$subv\">URL</a>";
	}elsif( $oth =~ /successfuly/ ){
		print "<center>";
		if( isTBadmin() ){
			print "weXI\n";
		}else{
			print "D`P¡I\n";
		}
		print "</center>";
		print "<form><input type=button class=button onclick=\"window.close()\" value=\"Close\" /></form></body></html>\n";
    	exit;
	}else{
	    print "@_" if @_;
		print "</body></html>\n";
	    exit;
	}
    print <<HTML;
<form method="post"><input type="hidden" name="__mode" value="send_ping" />
<table border="0" cellspacing="3" cellpadding="0">
<tr><td colspan="2" align="center">TrackBackoeΪ<Br /><Br /></td></tr>
<tr><td colspan=2">$ping_url_for_blog $ping_url_str</td></tr>
<tr><td colspan ="2">&nbsp;</td></tr>
<tr><td colspan ="2">YzwTrackBackШϥΤUC</td></tr>
<tr><td align="left">zDG</td><td><input name="blog_name" size="35" /></td></tr>
<tr><td align="left">zODG</td><td><input name="title" size="35" /></td></tr>
<tr><td align="left">zOnG</td><td><input name="excerpt" size="60" /></td></tr>
<tr><td align="left">zOURL:</td><td><input name="url" size="60" value="" /></td></tr>
<tr><td></td><td><input class="button" type="submit" value="Send" /></td></tr>
</table>
</form>
HTML

if( isTBadmin() ){
my $str;
my $p=rindex($subv, "/");
my $tb_id=substr($subv, $p+1);
my($title, $msgall)=get_nicky_file($tb_id);
my($msg, $dummy)=split(/<BR>/, $msgall);
$msg=delTag($msg);
$title=delTag($title);
my $url_nicky=substr($subv, 0, $p);
$url_nicky=~s/tb.cgi/nicky.cgi/;
$url_nicky="$url_nicky?DT=$tb_id#$tb_id";
my $put_url="nicky.cgi?DT=$tb_id#$tb_id";
$dummy=from_file("./tb_admin.cgi");
my($dummy1, $page_title)=split(/\n/, $dummy);
$page_title=~s/\n|\r|\t//g;
while( $page_title=~s/ $// ){};

print $custom_admin;
}

    print $footer;
    exit;
}

sub password_form {
	my($header, $footer, $custom, $ping_msg, $custom_admin, $lst)=get_custom();
	my $str_sb="";
	my $page_title="";

	print header();
	print $header;
	if( -e "./tb_admin.cgi" ){
		my $dummy;
		$str_sb = <<HTML;
old Password<br />  <input name="old_key" type="password" /><br /><br />
HTML
#		if( isTBadmin() ){
			my $dat=from_file("./tb_admin.cgi");
			($dummy, $page_title)=split(/\n/, $dat);
			$page_title =~ s/\r|\n//g;
#		}
	}else{
		unless( -d "./tbdir" ){
			mkdir("./tbdir", 0777);
			unless( -d "./tbdir" ){
				print "tb.cgiҦbƧSCGIgJvC<br />ж}tb.cgiҦbƧgJvC<br /></bod></html>\n";
				exit;
			}
			mkdir("./rssdir", 0777);
		}
	}

	print <<HTML;
<form method="post" action="./tb.cgi">
<input type="hidden" name="__mode" value="setup_password" />
$str_sb
Password<br />  <input name="key" type="password" />
<br />
Page Title<br />
  <input type="text" name="page_title" value="$page_title" />
<br /><br />
<input class="button" type="submit" value="setup password" />
</form>
<form method="post" action="./tb.cgi">
<input type="hidden" name="__mode" value="dummy_password" />
<input class="button" type="submit" value="dummy password" />
</form>
</body></html>
HTML

	exit;
}

sub isadmin{
	my($pass)=@_;
	my $rtn=0;

	$pass=~s/\r|\n|\t| //g;
	open FH, "./tb_admin.cgi";
	binmode FH;
	my $past_pass=<FH>;
	close FH;
	$past_pass =~ s/\r|\n| //g;
	$rtn = 1 if( $past_pass eq crypt($pass, $Pkey) );

	$rtn;
}

sub isTBadmin{
	require CGI::Cookie;
	my %cookies = CGI::Cookie->fetch;
	my $rtn = 0;
	return $rtn unless $cookies{nkytb};
	my $key = $cookies{nkytb}->value || return $rtn;

	isadmin( $key );
}

sub password_done{
	my($header, $footer, $custom, $ping_msg, $custom_admin, $lst)=get_custom();
	my $key = param('key');
	my $str = $header;
	my $flag=0;

	if( -e "./tb_admin.cgi" ){
		my $old_key = param('old_key');
		my $past_pass;
		my $oky;

		if( isadmin( $old_key ) ){
			$flag=1;
		}else{
			$str .= "invalid password.";
		}
	}else{
		$flag=1;
	}

	if( $flag ){
		my($sec,$min,$hour,$mday,$mon,$year,$wday) = gmtime(time + 60*24*60*365);

		$wday = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday') [$wday];
		$mon  = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec')[$mon];
		my $datec = sprintf("%s, %02d\-%s\-%04d %02d:%02d:%02d GMT",$wday,$mday,$mon,$year+1900,$hour,$min,$sec);

		my $path=$ENV{REQUEST_URI};
		if( $path eq "" ){
			$path=$ENV{SCRIPT_NAME};
		}
		print "Set-Cookie: nkytb=$key; expires=$datec;path=$path;\n";
		print header();
		my $page_title=param('page_title');

		open FH, ">./tb_admin.cgi";
		binmode FH;
		print FH crypt($key, $Pkey);
		print FH "\n$page_title";
		close FH;
		$str .= "Done.";

	}else{
		print header();
	}
	$str .= "<form><input type=button class=button onclick=\"window.close()\" value=\"Close\" /></form></body></html>";
	$str;
}

sub dummy_password{
	my $str;
	my($header, $footer, $custom, $ping_msg, $custom_admin, $lst)=get_custom();

	if( isTBadmin() ){
		require CGI::Cookie;
		my $path=$ENV{REQUEST_URI};
		if( $path eq "" ){
			$path=$ENV{SCRIPT_NAME};
		}
		my $key="";
		my $cookie = CGI::Cookie->new(-name => 'nkytb',
						-value => $key,
						-path => $path,
						-expires =>  '-1M');
		$str = header(-cookie => $cookie);
	}else{
		$str = header();
		$str .= "Invalid PC<Br />";
	}

	$str .= $header;
	$str .=  "dummy password done.";
	$str .= $footer;
	$str;
}

sub delTag{
	my($str)=@_;
	my($p1,$p2);
	my $dst1;
	my $dst2;

	$str=~s/&/&amp;/g;
	$str=~s/\"/&quot;/g;
	return $str unless( $str =~ /</ );
	while( $str =~ />/ ){
		last if( $str !~ /</ );
		$p1=index($str, "<");
		$p2=index($str, ">");
		if( $p1 > $p2 ){
			$str=~s/>/&gt;/;
		}
		$p1=index($str, "<");
		$dst1=substr($str, 0, $p1);
		$dst2=substr($str,$p1);
		$p2=index($dst2, ">");
		if( $p2 > 0 ) {
			$dst2=substr($dst2, $p2+1);
		} else {
			$dst2=$dst2;
		}
		$str = "$dst1$dst2";
	}
	$str=~s/</&lt;/g;
	$str=~s/>/&gt;/g;
	$str;
}

sub get_nicky_file {
	my($opt)=@_;
	my $str="";
	my($y, $m, $d, $ds);
	my($Date, $Title, $Message, $GrpFileName, $Layout, $CommentRecv, $fit_size, $RepLayout, $tbRcv, $ctg, $NickyFname);

	$y=substr($opt, 0, 4);
	$m=substr($opt, 4, 2);
	$d=substr($opt, 6, 2);
	$ds=substr($opt, 8, 1);

	require('./nicky.cgi');
	eval('($NickyFname, $ctg)=&getNickyFname($y, $m, $d, $ds, 0)');
	if( $@ ){
		$NickyFname="$vDir/$y/$m$d$ds.nky";
	}
	if( open(FH, $NickyFname) ){
		binmode(FH);
		while(<FH>){
			$str .= $_;
		}
		close(FH);
	}
	($Date, $Title, $Message, $GrpFileName, $Layout, $CommentRecv, $fit_size, $RepLayout, $tbRcv) = split(/\x01/, $str);
	($Title, $Message);
}

sub get_custom{
	my($str, $header, $footer, $custom, $ping_msg, $custom_admin, $lst, $blogname_max, $title_max, $excerpt_max, $mto);
	if( open FH, "./tb_custom.cgi" ){
		binmode FH;
		$str .= $_ while <FH> ;
		close FH;
		($header, $footer, $custom, $ping_msg, $custom_admin, $lst, $blogname_max, $title_max, $excerpt_max, $mto)=split(/\x01/, $str);
	}else{
		$header=<<HEADER;
<?xml version="1.0" encoding="BIG5"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html>
<head>
<title>Trackback</title>
<style type="text/css">
.title_logo{font-family:Arial;font-size:large;font-weight:bold;color:#ffffff;background:#003366;align:right;padding-left:15px;padding-right:15px;padding-top:5px;padding-bottom:5px;width:100%;text-align:right;}
.url{font-family:Arial;font-size:12px;font-weight:normal;background:#FFF;line-height:140%;padding:5px;border:1px dotted #444; }
.track{font-size:10px;font-weight:normal;background:#FFF;line-height:140%;padding:5px;border:1px dotted #999; }
.trackcm{font-family:Arial;font-size:14px;font-weight:normal;background:#FFF;line-height:140%;padding:5px;width:15%; }
.trackmsg{font-family:Arial;font-size:14px;font-weight:normal;background:#FFF;line-height:140%;padding:5px; }
.button{border:1px solid #cccccc;color:#999999;background-color:#ffffff;}
.pu{border-top:solid 1px #456;border-bottom:solid 1px #456;border-left:none;border-right:none;text-align:center;}
</style>
</head>
<body>
<div class="title_logo">TrackBack</div>
<div>
<br />
HEADER
		$footer=<<FOOTER;
<form method="post" action="$tbpath"><div><input type="hidden" name="__mode" value="send_ping" />
<table border="0" cellspacing="3" cellpadding="0" summary="input form">
<tr><td colspan ="2">YzwTrackBackШϥΤUC<input type="hidden" name="ping_url" value="\$url_ping" /></td></tr>
<tr><td align="left">zDG</td></tr>
<tr><td><input name="blog_name" size="35" value="" /></td></tr>
<tr><td align="left">zODG</td></tr>
<tr><td><input name="title" size="35" value="" /></td></tr>
<tr><td align="left">zOnG</td></tr>
<tr><td><input name="excerpt" size="60" value="" /></td></tr>
<tr><td align="left">zOURLG</td></tr>
<tr><td><input name="url" size="60" value="" /></td></tr>
<tr><td><input class="button" type="submit" value="eX" /></td></tr>
</table>
</div></form>
<center><form action="$tbpath"><div><input type="button" class="button" onclick="window.close()" value="" /></div></form></center>
</div>
</body></html>
FOOTER
		$custom=<<CUSTOM;
<div class="track">
<table border="0" width="95%" summary="Recv Msg">
<tr><td colspan="2">
<a href="\$url" class="trackmsg">\$tb_title</a></td></tr>
<tr><td class="trackcm">D</td><td valign="top" class="trackmsg">\$blog_name</td></tr>
<tr><td class="trackcm">n</td><td valign="top" class="trackmsg">\$excerpt</td></tr>
<tr><td colspan="2" align="right" class="trackmsg">\$time\$delete</td></tr>
</table>
</div><br />
CUSTOM
		$ping_msg=<<PING_MSG;
<div class="url">ODG<a href="\$url_nicky">\$title</a><br />
nޥΥgOɪ TrackBack <a href="\$url_ping">URI</a> pUG<br />
\$url_ping</div>
<br />
PING_MSG
		$custom_admin=<<CUSTOM_ADMIN;
<p class="pu">HUTu|X{b޲zPCC</p>
<center>gUHqnicky!eXTrackBackC</center>
<form method="post" action="$tbpath"><div><input type="hidden" name="__mode" value="send_ping" />
<table border="0" cellspacing="3" cellpadding="0">
<tr><td align="left">TrackBackURLG</td></tr>
<tr><td><input type="text" name=\"ping_url\" size=\"60\" /></td></tr>
<tr><td align="left">DG</td></tr>
<tr><td><input name="blog_name" value="\$page_title" size="35" /></td></tr>
<tr><td align="left">ODG</td></tr>
<tr><td><input name="title" size="35" value="\$title" /></td></tr>
<tr><td align="left">OnG</td></tr>
<tr><td><input name="excerpt" size="60" value="\$msg" /></td></tr>
<tr><td align="left">OURLG</td></tr>
<tr><td><input type="hidden" name="url" size="60" value="\$url_nicky" />
<a href="\$url_nicky" target="_blank">URI</a>
</td></tr>
<tr><td><input class="button" type="submit" value="eX" /></td></tr>
</table>
</div></form>
<p class="pu">޲zPCMΰT즹</p>
CUSTOM_ADMIN
		$lst="new";
		$blogname_max = $title_max = $excerpt_max = 1024;
	}

	($header, $footer, $custom, $ping_msg, $custom_admin, $lst, $blogname_max, $title_max, $excerpt_max, $mto);
}

sub edit_tb {
my($header, $footer, $custom, $ping_msg, $custom_admin, $lst, @lmax)=get_custom();
my $str=header();
unless( isTBadmin() ){
	print $str, "\n\n", $header, "invalid access", $footer;
	exit;
}
$header=~s/</&lt;/g;
$ping_msg=~s/</&lt;/g;
$footer=~s/</&lt;/g;
$custom=~s/</&lt;/g;
my($blogname_max, $title_max, $excerpt_max, $mto)=@lmax;
my($sendmail_path, $mail_address)=split(/\x02/, $mto);
my($str1, $str2);
if( $lst ne "new" ){
	$str1=" checked";
	$str2="";
}else{
	$str1="";
	$str2=" checked";
}
$str.=<<HTML;
<html>
<head>
<meta http-equiv="Content-type" content="text/html; charset=BIG5">
</head>
<body>
<div>
Ver $VERSION<br />
<form method="post" action="./tb.cgi">
OƱƦC覡G<input type="radio" name="sortlist" value="new"$str1>¦ܷs  
<input type="radio" name="sortlist" value="old"$str2>ѷs
<br />
YsgG<input type="submit" name="__mode" value="gJ"><br />
<textarea name="header" rows="20" cols="80">$header</textarea>
<br /><br />PingTsgG<input type="submit" name="__mode" value="gJ"><br />
<textarea name="ping_msg" rows="6" cols="80">$ping_msg</textarea>
<br /><br />ɧsgG<input type="submit" name="__mode" value="gJ"><br />
<textarea name="footer" rows="6" cols="80">$footer</textarea>
<br /><br />TrackBackG<input type="submit" name="__mode" value="gJ"><br />
<textarea name="custom" rows="12" cols="80">$custom</textarea>
<br /><br />޲ẕMΪG<input type="submit" name="__mode" value="gJ"><br />
<textarea name="custom_admin" rows="12" cols="80">$custom_admin</textarea>
<br />
Wٳ̤j=
<input type="text" name="blogname_max" value="$blogname_max" size="4">
, OƼD̤j=
<input type="text" name="title_max" value="$title_max" size="4">
, OƤe̤j=
<input type="text" name="excerpt_max" value="$excerpt_max" size="4">
<br />sendmail|
<input type="text" name="sendmail_path" value="$sendmail_path" size="32">
  mail address
<input type="text" name="mail_address" value="$mail_address" size="32">

<br /><input type="submit" name="__mode" value="]w"><br />
</form>
</div>
</body>
</html>
HTML
print $str;
}

sub write_custom {
my $str=header();
unless( isTBadmin() ){
	print $str, "\n\ninvalid access";
	exit;
}
my $header=param('header');
my $footer=param('footer');
my $custom=param('custom');
my $ping_msg=param('ping_msg');
my $custom_admin=param('custom_admin');
my $lst=param('sortlist');
my $blogname_max=param('blogname_max');
my $title_max=param('title_max');
my $excerpt_max=param('excerpt_max');
my $smpath=param('sendmail_path');
my $mailaddress=param('mail_address');

$header=~s/\r//g;
$footer=~s/\r//g;
$custom=~s/\r//g;
$ping_msg=~s/\r//g;
$custom_admin=~s/\r//g;
$smpath=~s/\r|\n//g;
$mailaddress=~s/\r|\n//g;

if( open FH, ">./tb_custom.cgi" ){
	binmode FH;
	print FH "$header\x01";
	print FH "$footer\x01";
	print FH "$custom\x01";
	print FH "$ping_msg\x01";
	print FH "$custom_admin\x01";
	print FH "$lst\x01";
	print FH "$blogname_max\x01";
	print FH "$title_max\x01";
	print FH "$excerpt_max\x01";
	print FH "$smpath\x02";
	print FH "$mailaddress";
	close FH;
	$str.="Done\n";
}else{
	$str.="Do not file Write\n";
}
print $str;
}

sub goto_keisicho {
#print "<META HTTP-EQUIV=\"REFRESH\" CONTENT=\"0;URL=http://www.npa.go.jp/hightech/\">\n</head></html>";
exit;
}

my(%Map, $RE);
BEGIN {
    %Map = ('&' => '&amp;', '"' => '&quot;', '<' => '&lt;', '>' => '&gt;');
    $RE = join '|', keys %Map;
}
sub xml {
    (my $s = defined $_[1] ? $_[1] : '') =~ s!($RE)!$Map{$1}!g;
#   "<$_[0]>" . enc($s) . "</$_[0]>\n";
	"<$_[0]>" . $s . "</$_[0]>\n";
}

sub encode_url {
    (my $str = $_[0]) =~ s!([^a-zA-Z0-9_.-])!uc sprintf "%%%02x", ord($1)!eg;
    $str;
}

sub from_file {
	my($file) = @_;
	local *FH;
	my $c="";
	if( open FH, $file ){
		binmode FH;
		{ local $/; $c = <FH> }
		close FH;
	}
	$c;
}

__END__

=head1 NAME

tb-standalone - Standalone TrackBack

=head1 DESCRIPTION

The standalone TrackBack tool serves two purposes: 1) it allows non-Movable
Type users to use TrackBack with the tool of their choice, provided they meet
the installation requirements; 2) it serves as a reference point to aid
developers in implementing TrackBack in their own systems. This tool is a
single CGI script that accepts TrackBack pings through HTTP requests, stores
the pings locally in the filesystem, and can return a list of pings either
in RSS or in a browser-viewable format. It can also be used to send pings
to other sites.

It is released under the Artistic License. The terms of the Artistic License
are described at I<http://www.perl.com/language/misc/Artistic.html>.

=head1 REQUIREMENTS

You'll need a webserver capable of running CGI scripts (this means, for
example, that this won't work with BlogSpot-hosted blogs). You'll also need
perl, and the following Perl modules:

=over 4

=item * File::Spec

=item * Storable

=item * CGI

=item * CGI::Cookie

=item * LWP

=back

The first four are core modules as of perl 5.6.0, I believe, and LWP is
installed on most hosts. Furthermore LWP is only required if you wish to
B<send> TrackBack pings.

=head1 INSTALLATION

Installation of the standalone TrackBack tool is very simple. It's just one
CGI script, F<tb.cgi>, along with two text files that define the header and
footer HTML for the public list of TrackBack pings.

=over 4

=item 1. Configure tb.cgi

You'll need to edit the script to change the I<$DataDir>, I<$RSSDir>,
and I<$Password> settings.

B<BE SURE TO CHANGE THE I<$Password> BEFORE INSTALLING THE TOOL.>

I<$DataDir> is the path to the directory where the TrackBack data
files will be stored; I<$RSSDir> is the path to the directory where the static
RSS files will be generated; I<$Password> is your secret password that will
allow you to delete TrackBack pings, when logged in.

After setting I<$DataDir> and I<$RSSDir>, you'll need to create both of these
directories and make them writeable by the user running the CGI scripts. In
most cases, this means that you must set the permissions on these directories
to 777.

=item 2. Upload Files

After editing the settings, upload F<tb.cgi>, F<header.txt>, and F<footer.txt>
in ASCII mode to your webserver into a directory where you can run CGI
scripts. Set the permissions on F<tb.cgi> to 755.

=back

=head1 USAGE

=head2 Sending Pings

To send pings from the tool, go to the following URL:

    http://yourserver.com/cgi-bin/tb.cgi?__mode=send_form

where I<http://yourserver.com/cgi-bin/tb.cgi> is the URL where you
installed F<tb.cgi>. Fill out the fields in the form, then press I<Send>.

=head2 Receiving Pings

To use the tool in your existing pages, you'll need to do two things:

=over 4

=item 1. Link to TrackBack listing

First, you'll need to add a link to each of your weblog entries with a
link to the list of TrackBack pings for that entry. You can do this by
adding the following HTML to your template:

    <a href="http://yourserver.com/cgi-bin/tb.cgi?__mode=list&tb_id=[TrackBack ID]" onclick="window.open(this.href, 'trackback', 'width=480,height=480,scrollbars=yes,status=yes'); return false">TrackBack</a>

You'll need to change C<http://yourserver.com/cgi-bin/tb.cgi> to the proper
URL for I<tb.cgi> on your server. And, depending on the weblogging tool that
you use, you'll need to change C<[TrackBack ID]> to a unique post ID. See
the L<conversion table below|Conversion Table> to determine the proper tag to
use for the tool that you use, to generate a unique post ID.

=item 2. Add RDF

TrackBack uses RDF embedded within your web page to auto-discover
TrackBack-enabled entries on your pages. It also uses this information when
building a threaded list of a cross-weblog "discussion". For these purposes,
it is useful to embed the RDF into your page.

Add the following to your weblog template so that it is displayed for each
of the entries on your page:

    <!--
    <rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
             xmlns:dc="http://purl.org/dc/elements/1.1/"
             xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/">
    <rdf:Description
        rdf:about="[Entry Permalink]"
        dc:title="[Entry Title]"
        dc:identifier="[Entry Permalink]" />
        trackback:ping="http://yourserver.com/cgi-bin/tb.cgi/[TrackBack ID]"
    </rdf:RDF>
    -->

As above, the tags that you should use for C<[TrackBack ID]>,
C<[Entry Title]>, and C<[Entry Permalink]> all depend on the weblogging tool
that you are using. See the L<conversion table below|Conversion Table>.

=back

=head2 Conversion Table

=over 4

=item * Blogger

TrackBack ID = C<E<lt>$BlogItemNumber$E<gt>>

Entry Title = C<E<lt>PostSubjectE<gt>E<lt>$BlogItemSubject$E<gt>E<lt>/PostSubjectE<gt>>

Entry Permalink = C<E<lt>$BlogItemArchiveFileName$E<gt>#E<lt>$BlogItemNumber$E<gt>>

=item * GreyMatter

TrackBack ID = C<{{entrynumber}}>

Entry Title = C<{{entrysubject}}>

Entry Permalink = C<{{pagelink}}>

=item * b2

TrackBack ID = C<E<lt>?php the_ID() ?E<gt>>

Entry Title = C<E<lt>?php the_title() ?E<gt>>

Entry Permalink = C<E<lt>?php permalink_link() ?E<gt>>

=item * pMachine

TrackBack ID = C<%%id%%>

Entry Title = C<%%title%%>

Entry Permalink = C<%%comment_permalink%%>

=item * Bloxsom

TrackBack ID = C<$fn>

Entry Title = C<$title>

Entry Permalink = C<$url/$yr/$mo/$da#$fn>

Thanks to Rael for this list of conversions.

=back

=head1 POSSIBLE USES

=over 4

=item 1. Content repository

Like Movable Type's TrackBack implementation, this standalone script can
be used to power a distributed content repository. The value of the I<tb_id>
parameter does not necessarily have to be an integer, because all it is used
for is a filename (B<note> that this is not true of most other TrackBack
implementations). For example, if you run a site about cats, and want to have
a way for users to ping your site with entries they write about their own
cats, you could set up a TrackBack URL like
F<http://www.foo.com/bar/tb.cgi?tb_id=cats>, then give that URL out on your
site. End users could then associate this URL with a I<Cats> category in
their own blog, and ping you whenever they wrote about cats.

=item 2. Building block

You can use this simple implementation as a building block, or a guide, for
implementing TrackBack in your own system. It illustrates the core
functionality of the TrackBack framework, onto which you could add bells
and whistles (IP banning, password-protected TrackBacks, etc).

=item 3. Centralized tool

This TrackBack tool requires that the end user have the ability to run CGI
scripts on their server. For many users (eg BlogSpot users), this is not
an option. For such users, a centralized system (based on this tool, perhaps)
would be ideal.

=back

=cut

